Name:       libyaml
Version:    0.2.5
Release:    6
Summary:    A C library for parsing and emitting YAML
License:    MIT
URL:        https://github.com/yaml/libyaml
Source0:    https://github.com/yaml/libyaml/releases/download/%{version}/yaml-%{version}.tar.gz

Patch0:     fix-heap-buffer-overflow-in-yaml_emitter_emit_flow_m.patch 
Patch1:     backport-Improve-CMake-build-system.patch
Patch2:     backport-CVE-2024-3205-Fix-emitter-states-handling-when-write_indicator-fails.patch

BuildRequires:  gcc

%description
YAML is a data serialization format designed for human readability and
interaction with scripting languages.  LibYAML is a YAML parser and
emitter written in C.

%package devel
Summary:   Development files for LibYAML applications
Requires:  libyaml = %{version}-%{release}, pkgconfig

%description devel
The %{name}-devel package contains libraries and header files for
developing applications that use LibYAML.

%package help
Summary:    Documents for using LibYAML
BuildArch:  noarch

%description help
%{summary}.


%prep
%autosetup -n yaml-%{version} -p1

%build
%configure --enable-static=no
%make_build

%install
%make_install

rm -vf %{buildroot}%{_libdir}/*.la

soname=$(readelf -d %{buildroot}%{_libdir}/libyaml.so | awk '$2 == "(SONAME)" {print $NF}' | tr -d '[]')
rm -f %{buildroot}%{_libdir}/libyaml.so
echo "INPUT($soname)" > %{buildroot}%{_libdir}/libyaml.so

%check
make check

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%license License
%doc ReadMe.md
%{_libdir}/%{name}*.so.*


%files devel
%defattr(-,root,root)
%{_libdir}/%{name}*.so
%{_libdir}/pkgconfig/yaml-0.1.pc
%{_includedir}/yaml.h

%files help
%doc doc/html


%changelog
* Thu Apr 25 2024 fuanan <fuanan3@h-partners.com> - 0.2.5-6
- fix CVE-2024-3205

* Sat May 27 2023 fuanan <fuanan3@h-partners.com> - 0.2.5-5
- Support cmake build system
- Modify URL and Source0

* Fri Nov 18 2022 chenziyang <chenziyang4@huawei.com> - 0.2.5-4
- Fix heap buffer overflow in yaml_emitter_emit_flow_sequence_item

* Mon Apr 18 2022 panxiaohe <panxh.life@foxmail.com> - 0.2.5-3
- fix heap buffer overflow in yaml_emitter_emit_flow_mapping_key

* Wed Feb 23 2022 fuanan <fuanan3@h-partners.com> - 0.2.5-2
- fix typo in spec

* Mon Jul 27 2020 Hugel <gengqihu1@huawei.com> - 0.2.5-1
- update to 0.2.5

* Wed Mar 18 2020 Leo Fang <leofang_94@163.com> - 0.2.2-2
- Fix overwrite the soname symlink bug in spec

* Tue Sep 3 2019 openEuler Buildteam <buildteam@openeuler.org> - 0.2.2-1
- Package init
